/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _Component = require(

'./Component');var _Component2 = _interopRequireDefault(_Component);

var PAGE_VENDOR = '__page';

/**
 * Used to register page and reusable components. Canonical reference for
 * pages and components at server side.
 */var 
ComponentRegister = (function () {





  function ComponentRegister() {_classCallCheck(this, ComponentRegister);
    this._components = {};}


  /**
   * @returns {?{[key: string]: Component}}
   */_createClass(ComponentRegister, [{ key: 'getPages', value: 
    function getPages() {
      return this.getComponents(PAGE_VENDOR);}


    /**
     * @returns {?{[key: string]: Component}}
     */ }, { key: 'getComponents', value: 
    function getComponents(vendor) {
      return this._components[vendor];}


    /**
     * @param {string} name
     * @param {string} absDir
     * @param {any} clazz
     */ }, { key: 'regPage', value: 
    function regPage(name, absDir, clazz) {
      if (typeof clazz.prototype.init != 'function') {
        throw new Error('Page class doesn\'t implement init(): ' + absDir);}

      if (typeof clazz.prototype.render != 'function') {
        throw new Error('Page class doesn\'t implement render(): ' + absDir);}

      this._regComponent(PAGE_VENDOR, name, absDir, clazz);}


    /**
     * @param {string} name
     * @returns {?Component}
     */ }, { key: 'getPage', value: 
    function getPage(name) {
      return this.getComponent(PAGE_VENDOR, name);}


    /**
     * @param {string} name
     * @returns {boolean}
     */ }, { key: 'hasPage', value: 
    function hasPage(name) {
      return this.hasComponent(PAGE_VENDOR, name);}


    /**
     * @param {string} vendor
     * @param {string} name
     * @param {string} absDir
     * @param {any} clazz
     */ }, { key: 'regComponent', value: 
    function regComponent(vendor, name, absDir, clazz) {
      if (vendor[0] == '_') {
        throw new Error('Component vendor name must not start with underscore: ' + vendor);}

      this._regComponent(vendor, name, absDir, clazz);}


    /**
     * @param {string} vendor
     * @param {string} name
     * @param {string} absDir
     * @param {any} clazz
     */ }, { key: '_regComponent', value: 
    function _regComponent(vendor, name, absDir, clazz) {
      if (!this._components.hasOwnProperty(vendor)) {
        this._components[vendor] = {};}

      if (typeof clazz != 'function') {
        throw new Error('Unable to load component: ' + absDir);}

      this._components[vendor][name] = new _Component2['default'](name, absDir, clazz);}


    /**
     * @param {string} vendor
     * @param {string} name
     * @return {?Component}
     */ }, { key: 'getComponent', value: 
    function getComponent(vendor, name) {
      return this._components[vendor][name];}


    /**
     * @param {string} vendor
     * @param {string} name
     * @returns {boolean}
     */ }, { key: 'hasComponent', value: 
    function hasComponent(vendor, name) {
      return this._components.hasOwnProperty(vendor) && this._components[vendor].hasOwnProperty(name);} }]);return ComponentRegister;})();exports['default'] = ComponentRegister;module.exports = exports['default']; /**
                                                                                                                                                                                                                       * @type {{[key: string]: {[key:string]: Component}}}
                                                                                                                                                                                                                       */
//# sourceMappingURL=ComponentRegister.js.map