/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _Compiler2 = require(

'../Compiler');var _Compiler3 = _interopRequireDefault(_Compiler2);var _CompileResult = require(
'../CompileResult');var _CompileResult2 = _interopRequireDefault(_CompileResult);var _EntryPoint = require(
'../../EntryPoint');var _EntryPoint2 = _interopRequireDefault(_EntryPoint);var _WebpackAssetServer = require(
'./WebpackAssetServer');var _WebpackAssetServer2 = _interopRequireDefault(_WebpackAssetServer);

var path = require('path');
var fs = require('fs');
var crypto = require('crypto');
var rimraf = require('rimraf');

// TODO: Disallow underscore at the beginning of pages directory!
var COMMONS_ENTRY_NAME = '__commons';var 

WebpackCompiler = (function (_Compiler) {_inherits(WebpackCompiler, _Compiler);








































  function WebpackCompiler(frameworkConfig /*: Object*/, webpack /*: any*/, react /*: any*/) {_classCallCheck(this, WebpackCompiler);
    _get(Object.getPrototypeOf(WebpackCompiler.prototype), 'constructor', this).call(this);
    this._react = react;
    this._webpack = webpack;
    this._frameworkConfig = frameworkConfig;
    this._clientReplace = frameworkConfig.clientReplace;
    this._clientResolve = frameworkConfig.clientResolve;
    this._absoluteClientBuildDir = frameworkConfig.absoluteClientBuildDir;
    this._assetHostPath = frameworkConfig.assetHostPath;
    this._assetServer = new _WebpackAssetServer2['default'](this._assetHostPath, this._absoluteClientBuildDir);
    this._cleanTempDir();}_createClass(WebpackCompiler, [{ key: 'run', 































































    /**
     * 1) Create configuration with one common file for webpack.
     * 2) Compile webpack from source to temporary location, with CSS loader
     *    and file loader.
     * 3) Read all files to AssetServer - AssetServer could just read the
     *    files, but cache everything.
     *
     *    TODO: Make babel optional
     *    TODO: Allow user setting of loaders.
     */value: 
    function run(entryPoints /*: Array<EntryPoint>*/, compileCallback /*: Function*/) {
      var i, j, entryPoint, entryPointList = [];
      var configuration = { 
        entry: {}, 
        output: { 
          path: this._absoluteClientBuildDir, 
          filename: "[name]-[chunkhash].js", 
          publicPath: 'http://' + this._assetHostPath }, 

        module: { 
          loaders: [
          WebpackCompiler.getBabelLoaderConfig(), 
          WebpackCompiler.getFileLoaderConfig(), 
          { test: /\.css$/, loader: "style-loader?returnComplete=true!css-loader" }] }, 


        babel: { 
          plugins: [
          "flow-comments", 
          { 
            transformer: this._createPlugin(), 
            position: 'after' }] }, 



        soya: { 
          assetHostPath: this._assetHostPath, 
          assetServer: this._assetServer }, 

        resolve: { 
          alias: {} }, 

        plugins: [] };


      for (i in this._clientReplace) {
        configuration.resolve.alias[i] = this._clientReplace[i];}


      var clientRuntime, entryPointFileName, pageToRequire;
      for (i = 0; i < entryPoints.length; i++) {
        entryPoint = entryPoints[i];
        pageToRequire = path.join(entryPoint.rootAbsolutePath, entryPoint.name + '.js');
        entryPointFileName = path.join(this._absoluteClientBuildDir, '__entry-' + entryPoint.name + '.js');
        clientRuntime = this._generateClientRuntime(pageToRequire);
        fs.writeFileSync(entryPointFileName, clientRuntime);
        configuration.entry[entryPoint.name] = entryPointFileName;
        entryPointList.push(entryPoint.name);}


      configuration.plugins.push(new this._webpack.optimize.CommonsChunkPlugin(
      COMMONS_ENTRY_NAME, 'common-[hash].js', entryPointList));


      if (this._frameworkConfig.minifyJs) {
        configuration.plugins.push(new this._webpack.optimize.UglifyJsPlugin({}));}


      var compiler = this._webpack(configuration);
      var self = this;
      compiler.run(function (err, stats) {
        if (stats.compilation.errors.length > 0) {
          // Error occured. Print error messages.
          self._printErrorMessages(stats);
          return;}


        var i, chunkMap = {};
        for (i = 0; i < stats.compilation.chunks.length; i++) {
          chunkMap[stats.compilation.chunks[i].name] = stats.compilation.chunks[i];}

        var commonsChunk = chunkMap[COMMONS_ENTRY_NAME];

        var compileResult = new _CompileResult2['default'](), entryPointChunk, entryPointName, pageDep;
        for (i = 0; i < entryPointList.length; i++) {
          entryPointName = entryPointList[i];
          if (!chunkMap.hasOwnProperty(entryPointName)) {
            throw new Error('Unable to determine dependency, entry point ' + entryPointName + ' does not have webpack chunk!');}

          entryPointChunk = chunkMap[entryPointName];

          pageDep = { 
            cssDependencies: [], 
            jsDependencies: [] };


          for (j = 0; j < commonsChunk.files.length; j++) {
            pageDep.jsDependencies.push(self._assetServer.toUrlWithoutProtocol(
            commonsChunk.files[j]));}


          for (j = 0; j < entryPointChunk.files.length; j++) {
            pageDep.jsDependencies.push(self._assetServer.toUrlWithoutProtocol(
            entryPointChunk.files[j]));}



          compileResult.pages[entryPointName] = pageDep;}


        compileCallback(compileResult);});}



    // TODO: Find out a library for escaping URLs to be put in HTML.
  }, { key: 'assembleHtml', value: function assembleHtml(componentName /*: string*/, routeArgs /*: Object*/, pageDependencies /*: Object*/, 
    renderResult /*: RenderResult*/, clientConfig /*: Config*/, isSecure /*: boolean*/) /*: string*/ {
      var result = '<html>';
      result += '<head>';
      result += renderResult.htmlHead;

      result += '<script type="text/javascript">';
      result += 'var config = ' + JSON.stringify(clientConfig) + ';';
      result += 'var routeArgs = ' + JSON.stringify(routeArgs) + ';';
      result += '</script>';

      var i, url, dep;
      for (i = 0; i < pageDependencies.cssDependencies.length; i++) {
        url = isSecure ? 'https://' : 'http://';
        url += pageDependencies.cssDependencies[i];
        result += '<link rel="stylesheet" type="text/css" src="' + url + '">';}


      result += '</head>';
      result += '<body><div id="__body">';
      result += this._react.renderToString(renderResult.reactElement);
      result += '</div>';

      for (i = 0; i < pageDependencies.jsDependencies.length; i++) {
        url = isSecure ? 'https://' : 'http://';
        url += pageDependencies.jsDependencies[i];
        result += '<script type="text/javascript" src="' + url + '"></script>';}


      result += '</body>';
      result += '</html>';
      return result;} }, { key: 'getAssetServer', value: 


    function getAssetServer() /*: AssetServer*/ {
      return this._assetServer;} }, { key: '_cleanTempDir', value: 


    function _cleanTempDir() {
      // Remove everything in the directory.
      rimraf.sync(this._absoluteClientBuildDir);

      // Ensure directory exists.
      try {
        fs.mkdirSync(this._absoluteClientBuildDir);} 
      catch (e) {
        if (e.code != 'EEXIST') throw e;}} }, { key: '_printErrorMessages', value: 



    function _printErrorMessages(stats /*: any*/) {
      console.log(stats.compilation.errors);} }, { key: '_generateClientRuntime', value: 


    function _generateClientRuntime(pageToRequire /*: string*/) {
      return 'var Page = require("' + pageToRequire.replace(/"/g, '\\"') + '");' + 
      'var React = require("react");' + 
      'var ClientHttpRequest = require("soya/lib/app/http/ClientHttpRequest");' + 
      'var page = new Page(); page.init(window.config);' + 
      'window.page = page;' + 
      'var renderResult = page.render(new ClientHttpRequest(), window.routeArgs);' + 
      'window.renderResult = renderResult;' + 
      'React.render(renderResult.reactElement, document.getElementById("__body"));';} }, { key: '_createPlugin', value: 


    function _createPlugin() {
      var self = this;
      return function (_ref) {var Plugin = _ref.Plugin;var t = _ref.types;
        return new Plugin("soya-swap-dependencies", { 
          visitor: { 
            CallExpression: function CallExpression(node, parent) {
              if (t.isIdentifier(node.callee, { name: "require" })) {
                var requireValue = node.arguments[0].value;
                if (self._clientResolve) {
                  var i, resolved;
                  for (i = 0; i < self._clientResolve.length; i++) {
                    // TODO: Pass also the absolute path of currently parsed file.
                    resolved = self._clientResolve[i](requireValue);
                    if (resolved != null) {
                      node.arguments[0].value = resolved;
                      return;}}}}} } });};} }], [{ key: 'createServerBuildConfig', value: function createServerBuildConfig(webpack, absProjectDir, absEntryPointFile, absBuildTargetDir) {var nodeModules = {};fs.readdirSync(path.join(absProjectDir, 'node_modules')).filter(function (x) {return ['.bin'].indexOf(x) === -1;}).forEach(function (mod) {nodeModules[mod] = 'commonjs ' + mod;});var definePlugin = new webpack.DefinePlugin({ __PROJECT_DIRNAME__: JSON.stringify(absProjectDir) });return { entry: absEntryPointFile, target: 'node', output: { path: absBuildTargetDir, filename: 'server.js' }, node: { __dirname: true, __filename: true }, devtool: 'sourcemap', module: { loaders: [WebpackCompiler.getBabelLoaderConfig(), WebpackCompiler.getFileLoaderConfig(), { test: /\.css$/, loader: "css-loader" }] }, plugins: [definePlugin, new webpack.BannerPlugin('require("source-map-support").install();', { raw: true, entryOnly: false })], externals: nodeModules };} }, { key: 'getBabelLoaderConfig', value: function getBabelLoaderConfig() {return { test: /\.jsx?$/, exclude: /(node_modules|bower_components)/, loader: 'babel', query: { optional: ['runtime'], plugins: ["flow-comments"], blacklist: ["flow"], retainLines: true, comments: false } };} }, { key: 'getFileLoaderConfig', value: function getFileLoaderConfig() {return { test: /(\.jpg|\.png|\.jpeg|\.gif|\.ico)$/, loader: "file-loader?name=[path][name]-[hash].[ext]" };} }]);return WebpackCompiler;})(_Compiler3['default']);exports['default'] = WebpackCompiler;module.exports = exports['default']; /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   * @type {{[key: string]: any}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * @type {string}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @type {{[key: string]: string}}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   * @type {Array<Function>}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       * @type {WebpackAssetServer}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */ /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               * @type {any}
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               */
//# sourceMappingURL=WebpackCompiler.js.map