'use strict';var Application = require('../../Application');
var WebpackCompiler = require('./WebpackCompiler');
var ComponentRegister = require('../../ComponentRegister');
var Router = require('../../router/Router');

/**
 * @param {Object} config
 * @param {any} webpack
 * @param {any} React
 * @param {ComponentRegister} register
 * @param {Router} router
 */
module.exports = function (config, webpack, React, register, router) {
  var frameworkConfig = config.frameworkConfig;
  var serverConfig = config.serverConfig;
  var clientConfig = config.clientConfig;

  if (!(register instanceof ComponentRegister)) {
    throw new Error('Given register is not an instance of ComponentRegister: ' + register);}

  if (!(router instanceof Router)) {
    throw new Error('Given router is not an instance of Router: ' + router);}


  var compiler = new WebpackCompiler(frameworkConfig, webpack, React);
  var application = new Application(
  register, router, compiler, frameworkConfig, serverConfig, clientConfig);

  application.run();};
//# sourceMappingURL=createServer.js.map