/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _ConfigJs = require(

'../Config.js');var _ConfigJs2 = _interopRequireDefault(_ConfigJs);var _RenderResultJs = require(
'./RenderResult.js');var _RenderResultJs2 = _interopRequireDefault(_RenderResultJs);var _httpServerHttpRequestJs = require(
'../http/ServerHttpRequest.js');var _httpServerHttpRequestJs2 = _interopRequireDefault(_httpServerHttpRequestJs);var _httpClientHttpRequestJs = require(
'../http/ClientHttpRequest.js');var _httpClientHttpRequestJs2 = _interopRequireDefault(_httpClientHttpRequestJs);

/**
 * Represents a web page with URL link. There are three different situations
 * where this class is used:
 *
 * 1. At server side, to generate HTML string.
 * 2. At client side after HTML is loaded, to create the main react element
 *    with the appropriate props so that it can start attaching event handlers.
 * 3. At client side at dynamic page change, to modify <head>, add JS and CSS
 *    dependencies, and render the main react component.
 *
 * NOTE: This class is supposed to be stateless. Only one instance is created
 * at server side and init() is only called once.
 */var 
Page = (function () {function Page() {_classCallCheck(this, Page);}_createClass(Page, [{ key: 'init', 
    /**
     * This method is run in both server and client side. This method should
     * instantiate all dependencies using the given config object and static
     * factories. The logic that it does should be the same since dependency
     * creation is offload to static factories, which are replaced by their
     * client side version at code compilation process.
     *
     * NOTE: Since Page is supposed to be stateless, init method is not given any
     * request context. You are supposed to only instantiate dependencies that
     * are reusable in all requests.
     */value: 
    function init(config /*: Object*/) {}



    /**
     * This method is also run in both server and client side. On server side,
     * framework code will generate a complete HTML document from RenderResult.
     * On client side, framework will just run the instantiated ReactComponent.
     */ }, { key: 'render', value: 
    function render(httpRequest /*: ServerHttpRequest | ClientHttpRequest*/, routeArgs /*: Object*/) /*: RenderResult*/ {
      return new _RenderResultJs2['default']();} }]);return Page;})();exports['default'] = Page;module.exports = exports['default'];
//# sourceMappingURL=Page.js.map