/* @flow */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var _pagePageJs = require(

'../page/Page.js');var _pagePageJs2 = _interopRequireDefault(_pagePageJs);var _EntryPointJs = require(
'../EntryPoint.js');var _EntryPointJs2 = _interopRequireDefault(_EntryPointJs);var _RouteResultJs = require(
'./RouteResult.js');var _RouteResultJs2 = _interopRequireDefault(_RouteResultJs);var _httpServerHttpRequest = require(
'../http/ServerHttpRequest');var _httpServerHttpRequest2 = _interopRequireDefault(_httpServerHttpRequest);var _RoutingData = require(
'./RoutingData');var _RoutingData2 = _interopRequireDefault(_RoutingData);var _PathNode = require(
'./PathNode');var _PathNode2 = _interopRequireDefault(_PathNode);var _FinalPathNode = require(
'./FinalPathNode');var _FinalPathNode2 = _interopRequireDefault(_FinalPathNode);

/**
 * Simple router implementation. You can create your own router implementation.
 * As long as it has the route() and  will do just fine
 *
 * 1) Parses route file and create array of entry points.
 * 2) Holds cache of Page instances and routes request to the Page instance.
 */var 
Router = (function () {

























  /**
   * @param {ComponentRegister} componentRegister
   * @param {?Array<Node>} preProcessNodes
   * @param {?Array<Node>} postProcessNodes
   */
  function Router(componentRegister, preProcessNodes, postProcessNodes) {_classCallCheck(this, Router);
    this._preProcessNodes = typeof preProcessNodes == 'Array' ? preProcessNodes : [];
    this._postProcessNodes = typeof postProcessNodes == 'Array' ? postProcessNodes : [];
    this._routeNodes = {};
    this._graph = [];
    this._componentRegister = componentRegister;}_createClass(Router, [{ key: 'reg', value: 


    function reg(routeId, pageName, startNodes, path, endNodes) {
      if (this._routeNodes.hasOwnProperty(routeId)) {
        throw new Error('Duplicate route ID: ' + routeId);}

      if (!this._componentRegister.hasPage(pageName)) {
        throw new Error('Route ' + routeId + ' made for non-existent page: ' + pageName);}

      if (!startNodes) startNodes = [];
      if (!endNodes) endNodes = [];
      var pathNodes = _PathNode2['default'].createFromPath(path);
      var i, nodes = [];
      for (i = 0; i < startNodes.length; i++) nodes.push(startNodes[i]);
      for (i = 0; i < pathNodes.length; i++) nodes.push(pathNodes[i]);
      for (i = 0; i < endNodes.length; i++) nodes.push(endNodes[i]);

      if (nodes.length < 1) {
        throw new Error('Invalid route, no nodes discovered: ' + routeId);}


      var parentNode;
      for (i = 0; i < this._graph.length; i++) {
        if (this._graph[i].equals(nodes[0])) {
          parentNode = this._graph[i];
          break;}}



      if (!parentNode) {
        // If no reusable parent node, add the node to the graph list and start
        // chaining from there.
        this._graph.push(nodes[0]);
        parentNode = nodes[0];}


      var curIndex = 1, children, foundEqual;
      while (curIndex < nodes.length) {
        if (!nodes[curIndex].isLeaf()) {
          throw new Error('User given route nodes must be leaf!');}


        foundEqual = false;
        children = parentNode.getChildren();
        for (i = 0; i < children.length; i++) {
          if (children[i].equals(nodes[curIndex])) {
            foundEqual = true;
            parentNode = children[i];
            break;}}


        if (!foundEqual) {
          parentNode.addChild(nodes[curIndex]);
          parentNode = nodes[curIndex];}

        curIndex++;}


      // Add setter node.
      parentNode.addChild(new _FinalPathNode2['default'](routeId, pageName));}


    /**
     * @param {ServerHttpRequest} httpRequest
     * @return {?RouteResult}
     */ }, { key: 'route', value: 
    function route(httpRequest) {
      var i, routingData = new _RoutingData2['default'](httpRequest, this._componentRegister);

      // Start pre processing. Pre processing may invalidate routes.
      for (i = 0; i < this._preProcessNodes.length; i++) {
        if (this._preProcessNodes[i].evaluate(routingData) !== true) return null;}


      // Start state based routing.
      this._routeRecursively(this._graph, routingData);

      // Start post processing. Post processing may invalidate routes.
      for (i = 0; i < this._postProcessNodes.length; i++) {
        if (this._postProcessNodes[i].evaluate(routingData) !== true) return null;}


      return routingData.createResult();} }, { key: '_routeRecursively', value: 


    function _routeRecursively(childNodes, routingData) {
      var i, childResult, found = false;
      for (i = 0; i < childNodes.length; i++) {
        // If the node doesn't match, no need to continue to its children.
        if (childNodes[i].evaluate(routingData) !== true) continue;

        if (childNodes[i].isLeaf()) {
          // If this is already the leaf, then it's a match.
          // Since it is guaranteed that all leaf is a FinalPathNode, this
          // guarantees that routing result is already set. We return true.
          return true;}


        // Else we need to recursively check all the children
        // until we reach the leaf.
        childResult = this._routeRecursively(childNodes[i].getChildren(), routingData);
        if (childResult === true) {
          found = true;
          break;}}


      return found;} }]);return Router;})();exports['default'] = Router;module.exports = exports['default']; /**
                                                                                                              * @type {Array<Node>}
                                                                                                              */ /**
                                                                                                                  * @type {Array<Node>}
                                                                                                                  */ /**
                                                                                                                      * @type {{[key: string]: Node}}
                                                                                                                      */ /**
                                                                                                                          * @type {Array<Node>}
                                                                                                                          */ /**
                                                                                                                              * @type {ComponentRegister}
                                                                                                                              */
//# sourceMappingURL=Router.js.map